# -*- coding: utf-8 -*-

#######################################################
###	current revison: Revision: 00 --> 00.00.0000	###
#######################################################

#######################################################
### imports											###
#######################################################
from global_defines import *
import globaltext

# >>> id			-->  KEY	--> STR
# >>> gender		-->  0		--> STR
# >>> party			-->  1		--> STR
# >>> x				-->  2		--> FLOAT
# >>> y				-->  3		--> FLOAT
# >>> name			-->  4		--> globaltext.NAME_...
# >>> direction		-->  5		--> FLOAT
# >>> resourceui	-->  6		--> STR
# >>> faction		-->  7		--> STR
# >>> level			-->  8		--> INT
# >>> model			-->  9		--> STR
# >>> gender		--> 10		--> STR
# >>> skin			--> 11		--> STR
# >>> clothes		--> 12		--> STR
# >>> face			--> 13		--> STR
# >>> scale			--> 14		--> FLOAT
# >>> active		--> 15		--> choice --> ACTIVE / INACTIVE

# EXAMPLE
# male	-->		npcs = {'MALE':			['male', 'NPCS', 300.00, 300.00, globaltext.M_NAME_MALE, 180.00, '',
#										 'VILLAGE_PEOPLE', 1, 'low', 'male', 'white', 'ss_001', 'evil19', 0.00, ACTIVE]}
# femal			npcs = {'FEMALE':		['female', 'NPCS', 300.00, 300.00, globaltext.M_NAME_FEMALE, 180.00, '',
#										 'VILLAGE_PEOPLE', 1, 'low', 'female', 'white', 'ss_001', 'evil01', 0.00, ACTIVE]}
# child male	npcs = {'CHILD_MALE':	['male', 'NPCS', 300.00, 300.00, globaltext.M_NAME_CHILD_MALE, 180.00, '',
#										 'VILLAGE_PEOPLE', 1, 'child', 'male', 'white', 'll_001', '002', 0.00, ACTIVE]}
# child female	npcs = {'CHILD_FEMALE':	['female', 'NPCS', 300.00, 300.00, globaltext.M_NAME_CHILD_FEMALE, 180.00, '',
#										 'VILLAGE_PEOPLE', 1, 'child', 'female', 'white', 'll_001', '001', 0.00, ACTIVE]}

# TODO: --> Write dictionary for all npcs
npcs = {}
""" Uncommment following lines to create your first NPC """
#npcs = {
#	'NPC_1':	['female', 'NPCS', 300.00, 305.00, 'Girl', 180.00, '',
#	 'VILLAGE_PEOPLE', 1, 'low', 'female', 'white', 'ss_001', 'evil01', 0.00, ACTIVE],
#	}
	
def init_npcs():
	for npc in npcs.keys():
		system.create_character(
			id			= npc,
			gender		= npcs[npc][0],
			party		= npcs[npc][1],
			x			= npcs[npc][2],
			y			= npcs[npc][3],
			name		= npcs[npc][4],
			direction	= npcs[npc][5],
			resourceui	= npcs[npc][6])
		objects.set_attributes(npc,
			faction		= npcs[npc][7],
			level		= npcs[npc][8],
			model		= npcs[npc][9],
			gender		= npcs[npc][10],
			skin		= npcs[npc][11],
			clothes		= npcs[npc][12],
			face		= npcs[npc][13])
		character.update_appearance(npc)
		if not npcs[npc][14] == 0.00:
			character.scale(npc, npcs[npc][14])
		objects.set_active_state(npc, npcs[npc][15])

			
			
# >>> id		--> KEY		--> STR
# >>> type		--> 0		--> choice --> ANIMAL_ANTELOPE, ANIMAL_BEAR, ANIMAL_TIGER, ANIMAL_BISON, ANIMAL_DONKEY, ANIMAL_DEER, ANIMAL_COW, ANIMAL_HORSE, ANIMAL_LIZARD, ANIMAL_WARG, ANIMAL_WILDDOG, ANIMAL_WOLF, ANIMAL_PIG
# >>> party		--> 1		--> STR
# >>> x			--> 2		--> FLOAT
# >>> y			--> 3		--> FLOAT
# >>> direction	--> 4		--> FLOAT

# EXAMPLE
# animals = {'ANIMAL': [ANIMAL_WOLF, 'ANIMALS', 300.00, 300.00,  180.00]}

# TODO: --> Write dictionary including all animals and update lists in const (data().animals / data().SpawnAnimals / data().pets)
animals = {}

def init_animals():
	for animal in animals.keys():
		system.create_animal(id 		= animal,
							 type 		= animals[animal][0],
							 party 		= animals[animal][1],
							 x 			= animals[animal][2],
							 y 			= animals[animal][3],)
							 #direction 	= animals[animal][4])
	
	for animal in data().animals:
		objects.set_attribute(animal,"foes", ["UISPIELER"])
	
	for animal in data().SpawnAnimals:
		objects.set_attribute(animal,"foes", ["UISPIELER"])
		objects.set_active_state(animal,INACTIVE)

## Spawns Animals
# Wrapper function: don't modify!

def spawnAnimals(state):
	if (state == ACTIVE):
		if not data().SpawnAnimalsSpawned:
			for animal in data().SpawnAnimals:
				objects.set_active_state(animal,state)
			data().SpawnAnimalsSpawned = True
	else:
		if data().SpawnAnimalsSpawned:
			for animal in data().SpawnAnimals:
				if not objects.is_destroyed(animal):
					objects.set_active_state(animal,state)
		data().SpawnAnimalsSpawned = False
